bug-coreutils
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

bug#15926: RFE: unlink command already uses 'unlink' call; make 'rm' use


From: Bernhard Voelker
Subject: bug#15926: RFE: unlink command already uses 'unlink' call; make 'rm' use 'remove' call
Date: Fri, 22 Nov 2013 15:56:27 +0100
User-agent: Mozilla/5.0 (X11; Linux x86_64; rv:24.0) Gecko/20100101 Thunderbird/24.1.0

On 11/21/2013 05:11 PM, Jim Meyering wrote:
Thanks for doing that.
I was a little surprised to see an rm diagnostic change, but no
corresponding change in any test.  Perhaps an opportunity for
increased test coverage?

Sure! ;-)

Have a nice day,
Berny

From 2fa074ebd43cbfea0f6b4bc92a4099a273458562 Mon Sep 17 00:00:00 2001
From: Bernhard Voelker <address@hidden>
Date: Fri, 22 Nov 2013 15:54:06 +0100
Subject: [PATCH] tests: enhance rm test regarding "." and ".."

Recent commit 2da7009d changed the error diagnostic of rm(1) trying
to remove "." or "..".  Enhance the corresponding test.

* tests/rm/r-4.sh: Ensure rm(1) outputs the expected error diagnostic.
---
 tests/rm/r-4.sh | 25 ++++++++++++++++++++-----
 1 file changed, 20 insertions(+), 5 deletions(-)

diff --git a/tests/rm/r-4.sh b/tests/rm/r-4.sh
index 94702a6..a3ceaf9 100755
--- a/tests/rm/r-4.sh
+++ b/tests/rm/r-4.sh
@@ -22,11 +22,26 @@ print_ver_ rm
 mkdir d || framework_failure_
 touch d/a || framework_failure_

-rm -fr d/. 2>/dev/null && fail=1
-rm -fr d/./ 2>/dev/null && fail=1
-rm -fr d/.//// 2>/dev/null && fail=1
-rm -fr d/.. 2>/dev/null && fail=1
-rm -fr d/../ 2>/dev/null && fail=1
+# Expected error diagnostic as grep pattern.
+exp="^rm: refusing to remove '\.' or '\.\.' directory: skipping '.*'\$"
+
+rmtest()
+{
+  # Try removing - expecting failure.
+  rm -fr "$1" 2> err && fail=1
+
+  # Ensure the expected error diagnostic is output.
+  grep "$exp" err || { cat err; fail=1; }
+
+  return $fail
+}
+
+rmtest 'd/.'     || fail=1
+rmtest 'd/./'    || fail=1
+rmtest 'd/.////' || fail=1
+rmtest 'd/..'    || fail=1
+rmtest 'd/../'   || fail=1
+

 # This test is too dangerous -- if there's a bug you're wiped out!
 # rm -fr / 2>/dev/null && fail=1
--
1.8.4.2






reply via email to

[Prev in Thread] Current Thread [Next in Thread]